---
title: RTCPeerConnection.onsignalingstatechange
slug: Web/API/RTCPeerConnection/onsignalingstatechange
tags:
  - API
  - Connectivity
  - Event Handler
  - ICE
  - Offer
  - Property
  - RTCPeerConnection
  - Reference
  - SDP
  - Signaling
  - WebRTC
  - WebRTC API
  - answer
  - onsignalingstatechange
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <code><strong>onsignalingstatechange</strong></code> event handler property of the <strong>{{domxref("RTCPeerConnection")}}</strong> interface specifies a function to be called when the {{event("signalingstatechange")}} event occurs on an {{domxref("RTCPeerConnection")}} interface.</span> The function receives as input the event object of type {{domxref("Event")}}; this event is sent when the peer connection's {{domxref("RTCPeerConnection.signalingState", "signalingState")}} changes, which may happen either because of a call to {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} or to {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtcPeerConnection</em>.onsignalingstatechange = <em>errorHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>Set this to a function which you provide that receives an {{domxref("Event")}} object as input; this contains the {{event("signalingstatechange")}} event. This event object doesn't provide details about what changed, but you can examine the {{domxref("RTCPeerConnection.signalingState", "signalingState")}} property to determine what the new state is.</p>

<p>You may also, as always, set up a handler for the {{domxref("RTCPeerConnection.signalingstatechange_event", "signalingstatechange")}} event using {{domxref("EventTarget.addEventListener", "addEventListener()")}}:</p>

<pre class="brush: js">myRTCPeerConnection.addEventListener("signalingstatechange", mySignalingStateChangeHandler);
</pre>

<p>Or, using an anonymous (inline) handler:</p>

<pre class="brush: js">myRTCPeerConnection.addEventListener("signalingstatechange", event =&gt; {
  /* handle the event here */
});</pre>

<h2 id="Example">Example</h2>

<p>This snippet shows a handler for {{event("signalingstatechange")}} that looks for the <code>"have-local-pranswer"</code> signaling state—indicating that a remote offer has been received and a local description of type <code>"pranswer"</code> has been applied in response.</p>

<pre class="brush: js">pc.onsignalingstatechange = function(event) {
  if (pc.signalingState === "have-local-pranswer") {
    // setLocalDescription() has been called with an answer
  }
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-onsignalingstatechange', 'RTCPeerConnection.onsignalingstatechange')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.onsignalingstatechange")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>: A WebRTC example</li>
 <li>The {{event("signalingstatechange")}} event and its type, {{domxref("Event")}}.</li>
</ul>
